data ch10_exB1;
/* nested factorial aka disconnected 10x3 */
/* this one - no overdispersion           */
seed=19022011;
blk_var=0.8;
 input block @@;
 bk=sqrt(blk_var)*rannor(seed);
  do eu=1 to 3;
   input trt @@; 
	a=(trt>2);
	b=(trt=1 or trt=4)+2*(trt=2 or trt=5); 
    prob=0.3*(a=0)+(a=1)*(0.26*(b=0)+0.34*(b=1)+0.42*(b=2));
	logit=log(prob/(1-prob));
	eta=logit+bk;
	pi=1/(1+exp(-eta));
	n=ranpoi(seed,40);
	f=ranbin(seed,n,pi);
    output;
  end;
 datalines;
 1  3 4 5
 2  3 4 5
 3  0 1 2
 4  0 1 2
 5  3 4 5
 6  3 4 5
 7  0 1 2
 8  0 1 2
 9  0 1 2
 10 3 4 5
 ; 
* proc print data=ch10_exB1;
* run;
/* on default PL */
 /* not shown in book*/
proc glimmix data=ch10_exB1;
 class block a b;
 model f/n=a b(a) / s;
 random a / subject=block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;
/* shown in book - quadrature */
/* run 1 - model-based */
ods rtf 
  file='C:\Documents and Settings\wstroup\My Documents\02-GLMM Book\RTF Files\Ex10B1_basic.rtf' 
   bodytitle style=Journal;
proc glimmix data=ch10_exB1 method=quad;
 class block a b;
 model f/n=a b(a); * / link=probit;
 random a / subject=block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;
ods rtf close;
quit;
run;
/* run 2 - empirical - classic sandwich estimator */
ods rtf 
  file='C:\Documents and Settings\wstroup\My Documents\02-GLMM Book\RTF Files\Ex10B1_ClscCndwch.rtf' 
   bodytitle style=Journal;
proc glimmix data=ch10_exB1 method=quad empirical;
 class block a b;
 model f/n=a b(a) / s;
 random a / subject=block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;
ods rtf close;
quit;
run;
/* run 3 - empirical - bias-corrected sandwich estimator */
/* default MBN settings - look like overkill here        */
ods rtf 
  file='C:\Documents and Settings\wstroup\My Documents\02-GLMM Book\RTF Files\Ex10B1_MBNCndwch.rtf' 
   bodytitle style=Journal;
proc glimmix data=ch10_exB1 method=quad empirical=mbn;
 class block a b;
 model f/n=a b(a) / s;
 random a / subject=block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;
ods rtf close;
quit;
run;

/* run 4 - empirical - bias-corrected sandwich estimator */
/*  MBN setting adjusted: D=12                           */
ods rtf 
  file='C:\Documents and Settings\wstroup\My Documents\02-GLMM Book\RTF Files\Ex10B1_MBNAdj_Sndwch.rtf' 
   bodytitle style=Journal;
proc glimmix data=ch10_exB1 method=quad empirical=mbn(d=12);
 class block a b;
 model f/n=a b(a);
 random a / subject=block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;
ods rtf close;
quit;
run;

/* miscellaneous other runs not shown in book */
/*
proc glimmix data=ch10_exB1 method=laplace;
 class block a b;
 model f/n=a b(a) / s;
 random a / subject=block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;
proc glimmix data=ch10_exB1 method=quad empirical;
 class block a b;
 model f/n=a b(a);
 random a / subject=block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;
proc glimmix data=ch10_exB1 method=quad empirical;
 class block a b;
 model f/n=a b(a);
 random a / subject=block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;
proc glimmix data=ch10_exB1 method=quad empirical=mbn;
 class block a b;
 model f/n=a b(a);
 random a / subject=block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;
*/
/*
proc glimmix data=ch10_exB1;
 class block a b;
 model f/n=a b(a)/ddfm=kr(firstorder);
 random a / subject=block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;
*/
