/* nested factorial aka disconnected 10x3 aka split-plot */
/* binomial data, no overdispersion                      */
data example_10_2;
 input Block Trt A B F N;
datalines;
1 3 1 0 16 37
1 4 1 1 16 38
1 5 1 2 21 45
2 3 1 0 11 47
2 4 1 1 15 52
2 5 1 2 15 37
3 0 0 0 29 51
3 1 0 1 17 35
3 2 0 2 20 39
4 0 0 0 4 44
4 1 0 1 4 35
4 2 0 2 8 42
5 3 1 0 13 39
5 4 1 1 24 39
5 5 1 2 20 36
6 3 1 0 15 45
6 4 1 1 9 30
6 5 1 2 11 30
7 0 0 0 14 31
7 1 0 1 23 30
7 2 0 2 21 28
8 0 0 0 19 41
8 1 0 1 19 37
8 2 0 2 7 26
9 0 0 0 21 36
9 1 0 1 20 36
9 2 0 2 22 36
10 3 1 0 8 43
10 4 1 1 17 49
10 5 1 2 17 40
;
/* run 1 - quadrature, model-based inferential statistics */
proc glimmix data=example_10_2 method=quad;
 class Block a b;
 model F/N=a b(a); 
 random a / subject=Block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;

/* run 2 - empirical - classic sandwich estimator */
proc glimmix data=example_10_2 method=quad empirical;
 class block a b;
 model f/n=a b(a) / s;
 random a / subject=block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;

/* run 3 - empirical - bias-corrected sandwich estimator */
/* default MBN settings - look like overkill here        */
proc glimmix data=example_10_2 method=quad empirical=mbn;
 class block a b;
 model f/n=a b(a) / s;
 random a / subject=block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;

/* run 4 - empirical - bias-corrected sandwich estimator */
/*  MBN setting adjusted: D=12                           */
proc glimmix data=example_10_2 method=quad empirical=mbn(d=12);
 class block a b;
 model f/n=a b(a);
 random a / subject=block;
 lsmeans b(a) / slice=a slicediff=a ilink;
run;
