/* Binomial Data from Box-Behnken design */
data example_10_3;
 input Block A B C y N;
 xa=a;
 xb=b;
 xc=c;
datalines;
1 0 1 1 17 34
1 0 1 -1 13 44
1 0 -1 1 9 31
1 0 -1 -1 15 36
2 1 0 1 15 29
2 1 0 -1 22 29
2 -1 0 1 17 28
2 -1 0 -1 8 32
3 1 1 0 4 32
3 1 -1 0 3 22
3 -1 1 0 3 35
3 -1 -1 0 4 31
4 0 1 1 19 39
4 0 1 -1 14 45
4 0 -1 1 8 31
4 0 -1 -1 6 25
5 1 0 1 15 31
5 1 0 -1 18 36
5 -1 0 1 13 31
5 -1 0 -1 6 36
6 1 1 0 12 31
6 1 -1 0 12 45
6 -1 1 0 10 42
6 -1 -1 0 7 40
7 0 0 0 17 28
7 0 0 0 24 31
7 0 0 0 17 28
7 0 0 0 18 26
;
/* step 1 - assess lack of fit */
proc glimmix data=example_10_3 method=quad;
 class block a b c;
 model y/n=xa|xa|xb|xb|xc|xc@2 a*b*c /  htype=1;
 random intercept  / subject=block;
run;

/* step 2 - fit full 2nd order polynomial regression */
proc glimmix data=example_10_3 method=quad;
 class block;
 model y/n=xa|xa|xb|xb|xc|xc@2 /  htype=1;
 random intercept  / subject=block;
run;

/* step 3 - fit reduced 2nd order polynomial regression implied by step 2 */
proc glimmix data=example_10_3 method=quad;
 class block;
 model y/n=xa|xa|xb|xb@2 xa*xc xb*xc / solution;
 random intercept  / subject=block;
run;
