/* Example 10.6 */
/* Incomplete Strip-Plot Design Introduced in Section 8.2 */
/* Binomial Data but Logit Link fits poorly               */
/* C Log Log more appropriate                             */
data exqample_10_6;
 input Block A B y N;
datalines;
1 1 1 62 69
1 1 2 67 69
1 2 1 60 62
1 2 2 64 67
2 1 1 67 67
2 1 3 74 74
2 2 1 79 83
2 2 3 64 64
3 1 2 62 63
3 1 3 74 74
3 2 2 55 58
3 2 3 65 65
4 1 1 56 59
4 1 2 66 66
4 3 1 56 59
4 3 2 70 75
5 1 1 47 58
5 1 3 60 60
5 3 1 48 61
5 3 3 57 59
6 1 2 56 56
6 1 3 58 58
6 3 2 47 47
6 3 3 59 59
7 2 1 43 57
7 2 2 45 46
7 3 1 44 64
7 3 2 53 53
8 2 1 44 54
8 2 3 57 60
8 3 1 64 76
8 3 3 49 53
9 2 2 56 56
9 2 3 55 55
9 3 2 45 49
9 3 3 53 56
;
/* 1 - model with default link                   */
/* output predicted values on data (ilink) scale */
proc glimmix data=ds8d2 method=laplace;
 class block a b;
 model y/n=a|b;;
 random intercept a b / subject=block;
 output out=check_fit_l pred(ilink)=p_hat_logit;
run;

/* create data to check observed vs. predicted       */
/* compute correlation and visualize via scatterplot */
data check_fit_l;
 set check_fit_l;
 sample_p=y/n;
proc corr data=check_fit_l;
 var p_hat_logit sample_p;
run;
goptions ftext='swiss' htitle=3 htext=2 vtext=2;
symbol value=star color=black;/* ---------- Setting horizonal axis titles and labels options. ---------- */
/* Horizontal */     axis1   label=(height=2 font='Swiss' "Sample Proportion")
/* Xaxis      */             order=0.68 to 1 by 0.02
/* Xaxis      */             value=(height=1 font='Swiss')
/* Xaxis      */             offset=(2,1)  /* left,right */
/* Xaxis      */             width=1.25            /* Thicknes of axis/frame line */
/* Xaxis      */             major=(h=-.35)        /* Major tick mark */
/* Xaxis      */             minor=(h=-.35 n=1);    /* Minor tick mark */
 
/* ---------- Setting verical axis titles and labels options. ---------- */
/* Vertical   */     axis2   label=(height=2 angle=90 font='Swiss'  "P_Hat")
/*      Yaxis */             order=0.70 to 1 by .02
/*      Yaxis */             value=(height=1 font='Swiss')
/*      Yaxis */             offset=(1 ,3) /* bottom,top */
/*      Yaxis */             width=1.25            /* Thicknes of axis/frame line */
/*      Yaxis */             major=(h=-.5)         /* Major tick mark */
/*      Yaxis */             minor=(h=-.35 n=1);   /* Minor tick mark */

proc gplot data=check_fit_l;
 plot p_hat_logit*sample_p/ haxis=axis1 vaxis=axis2;
 title 'obs Y/N vs p_hat for logit link';
run;

/* 2 - re-fit model using complementary log log link */
proc glimmix data=ds8d2 method=laplace;
 class block a b;
 model y/n=a|b/ link=ccll;
 random intercept a b / subject=block;
 output out=check_fit_c pred(ilink)=p_hat_ccll;
run;

/* create data to check observed vs. predicted       */
/* compute correlation and visualize via scatterplot */
data check_fit_c;
 set check_fit_c;
 sample_p=y/n;
proc corr data=check_fit_c;
 var p_hat_ccll sample_p;
run;
goptions ftext='swiss' htitle=3 htext=2 vtext=2;
symbol value=star color=black;/* ---------- Setting horizonal axis titles and labels options. ---------- */
/* Horizontal */     axis1   label=(height=2 font='Swiss' "Sample Proportion")
/* Xaxis      */             order=0.68 to 1 by 0.02
/* Xaxis      */             value=(height=1 font='Swiss')
/* Xaxis      */             offset=(2,1)  /* left,right */
/* Xaxis      */             width=1.25            /* Thicknes of axis/frame line */
/* Xaxis      */             major=(h=-.35)        /* Major tick mark */
/* Xaxis      */             minor=(h=-.35 n=1);    /* Minor tick mark */
 
/* ---------- Setting verical axis titles and labels options. ---------- */
/* Vertical   */     axis2   label=(height=2 angle=90 font='Swiss'  "P_Hat")
/*      Yaxis */             order=0.70 to 1 by .02
/*      Yaxis */             value=(height=1 font='Swiss')
/*      Yaxis */             offset=(1 ,3) /* bottom,top */
/*      Yaxis */             width=1.25            /* Thicknes of axis/frame line */
/*      Yaxis */             major=(h=-.5)         /* Major tick mark */
/*      Yaxis */             minor=(h=-.35 n=1);   /* Minor tick mark */

proc gplot data=check_fit_c;
 plot p_hat_ccll*sample_p/ haxis=axis1 vaxis=axis2;
 title 'obs Y/N vs p_hat for c-log-log link';
run;
