/* 3 way log-lin for Ch 10     */
/* example 10.4                */
/* A is the "treatment"        */
/* B is the response           */
/* C is the mitigating factor  */

data example_10_4;
 input a b c Freq;
datalines;
1 1 1 94
1 2 1 50
1 1 2 171
1 2 2 18
2 1 1 11
2 2 1 12
2 1 2 101
2 2 2 18
;
/* 1 - basic Log-Linear model */
proc glimmix data=ct1;
 class a b c;
 model freq=a|b|c/d=poisson ddfm=none chisq;
run;

/* 2 - Log-linear model with contrasts     */
/* contrast define conditional odds ratios */ 
proc glimmix data=ct;
 class a b c;
 model freq=c(a*b)/d=poisson chisq ddfm=none s;
 estimate 'a1 odds @ c1' c(a*b) 1 0 -1 0  0 0 0 0 / exp;
 estimate 'a1 odds @ c2' c(a*b) 0 1 0 -1  0 0 0 0 / exp;
 estimate 'a2 odds @ c1' c(a*b) 0 0 0 0  1 0 -1 0 / exp;
 estimate 'a2 odds @ c2' c(a*b) 0 0 0 0  0 1 0 -1 / exp;
 estimate 'odds ratio @ c1' c(a*b) 1 0 -1 0  -1 0 1 0 / exp cl;
 estimate 'odds ratio @ c2' c(a*b) 0 1 0 -1  0 -1 0 1 / exp cl;
 estimate 'comb odds ratio' c(a*b) 1 1 -1 -1  -1 -1 1 1 / exp cl;
run;

/* 3 - Simpson's paradox: if you don't take C into account, A x B assoc disappears */
proc freq;
 table a*b;
 weight freq;
run;
proc glimmix data=ct;
 class a b;
 model freq=a|b/d=poisson ddfm=none chisq;
run;
