Data example_10_5;
 input Block A B C y N;
  xa=a;
  xb=b;
  xc=c;
datalines;
1 0 1 1 7 27
1 0 1 -1 6 36
1 0 -1 1 6 46
1 0 -1 -1 0 43
2 1 0 1 22 48
2 1 0 -1 11 40
2 -1 0 1 14 49
2 -1 0 -1 0 35
3 1 1 0 13 43
3 1 -1 0 14 38
3 -1 1 0 0 49
3 -1 -1 0 2 45
4 0 1 1 4 42
4 0 1 -1 15 49
4 0 -1 1 7 50
4 0 -1 -1 17 35
5 1 0 1 15 44
5 1 0 -1 6 45
5 -1 0 1 16 42
5 -1 0 -1 10 42
6 1 1 0 0 38
6 1 -1 0 0 44
6 -1 1 0 1 37
6 -1 -1 0 0 50
7 0 0 0 15 55
7 0 0 0 4 41
7 0 0 0 35 53
7 0 0 0 28 49
;
/* 1 - naive model without unit level random effect */
proc glimmix data=example_10_5 method=quad;
 class block a b c;
 model y/n=xa|xa|xb|xb|xc|xc@2 a*b*c /  htype=1;
 random intercept /*a*b*c*/ / subject=block;
run;

/* 2 - include OD term                            */
/* must switch to Laplace - quad can't handle it  */
proc glimmix data=example_10_5 method=laplace;
 class block a b c;
 model y/n=xa|xa|xb|xb|xc|xc@2 a*b*c /  htype=1 ddf=5.5,5.5,5.5,5.5,5.5,5.5,5.5,5.5,5.5;
 random intercept a*b*c / subject=block;
 covtest 'overD?' . 0;
run;

/* 3 - illustration: results with default PL estimation */
proc glimmix data=example_10_5;
 class block a b c;
 model y/n=xa|xa|xb|xb|xc|xc@2 a*b*c /  htype=1 ddfm=satterth;
 random intercept a*b*c / subject=block;
run;
/* oft-used alternative: PL with scale parameter */
/* generally not recommended                     */
/* "WWFD illiterate"                             */
proc glimmix data=example_10_5;
 class block a b c;
 model y/n=xa|xa|xb|xb|xc|xc@2 a*b*c /  htype=1 ddfm=satterth;
 random intercept / subject=block;
 random _residual_;
run;
