/* Example 11.1.2 */
/* Data Set 11.1  */
data crd_counts;
 input trt count;
datalines;
1 0
1 7
1 3
1 4
1 7
2 8
2 7
2 12
2 4
2 10
;
/* 1 - Standard one-way ANOVA model */ 
proc glimmix data=CRD_Counts;
 class trt;
 model count=trt;
 lsmeans trt / diff;
run;   

/* 2 - one-way ANOVA model with log tranformation */ 
proc glimmix data=CRD_Counts;
 class trt;
 if count=0 then logc=log(count+0.1); else logc=log(count);
 model logc=trt;
 lsmeans trt / diff;
 ods output lsmeans=lsm;
run; 
/* back-transform lsmeans from model to data scale */
data data_scale_means;
 set lsm;
 lamda_hat=exp(estimate);
 StdErrLamda=exp(estimate)*stderr;  /* delta rule */
 /* for square root transform, back transofrmation functions are */ 
 /* 
 lamda_hat=estimate**2;
 StdErrLamda=2*estimate*stderr;
 */
proc print data=data_scale_means;
 var trt estimate stderr lamda_hat stderrlamda;
run; 

/* 3- Generalized Linear Model analog of one-way ANOVA */
proc glimmix data=CRD_Counts;
 class trt;
 model count=trt / d=poisson;
 lsmeans trt / diff ilink;
run; 
