/* chapter 12, example 1      */
/* split-plot with gamma data */
data ch12_ex1;
 input block a b days;
datalines;
1 1 1 49
1 1 2 13
1 2 1 58
1 2 2 70
1 3 1 22
1 3 2 37
2 1 1 21
2 1 2 8
2 2 1 64
2 2 2 37
2 3 1 44
2 3 2 72
3 1 1 44
3 1 2 45
3 2 1 54
3 2 2 63
3 3 1 29
3 3 2 18
4 1 1 9
4 1 2 5
4 2 1 3
4 2 2 4
4 3 1 19
4 3 2 33
;
/* time to germination / flowering / etc */
ods graphics on;
/* run 1 - why not to analyze these data as Gaussian */
/*  CI for LMS of A1 B2 not bounded below by 0       */
/*  residual plot skewed                             */
/*  variance appears to increase as y increases      */
proc glimmix data=ch12_ex1 plot=residualpanel;
 class block a b;
 model days=a|b;
 random intercept a/subject=block;
 lsmeans a*b / cl;
run;
/* MEANS show variance/mean relationship */
proc glm data=ch12_ex1;
 class block a b;
 model days=a|b block block*a/p;
 means a*b;
 output out=pr p=yhat r=yres;
run;
proc print data=pr;
run;
proc sort data=pr;
 by a b;
proc means noprint data=pr;
 by a b;
 var yhat yres;
 output out=prm mean=myhat myres var=vyhat vyres;
run;
proc print data=prm;
run;

/* now do it right with GLIMMIX  */
/* stress LSM, variance-mean, any differences in test stats  */
proc glimmix data=ch12_ex1 plot=residualpanel(ilink) noprofile;
 class block a b;
 model days=a|b / d=gamma;
 random intercept a/subject=block;
 lsmeans a*b / slicediff=(a b) ilink cl;
 covtest /cl(type=plr);
run;
