/* Chapter 12, Section 12.2.2  */
/* response surface estimation */
/* time to even data           */
/* Box Behnken design          */
data response_times;
 input run a b c r_time;
datalines;
1 1 0 0 18750
1 1 0 2 22308
1 1 2 0 14906
1 1 2 2 11302
2 0 1 0 12509
2 0 1 2 8294
2 2 1 0 6808
2 2 1 2 7082
3 0 0 1 4960
3 0 2 1 3395
3 2 0 1 2521
3 2 2 1 764
4 1 1 1 1679
4 1 1 1 3562
4 1 1 1 4635
4 1 1 1 772
5 1 0 0 14751
5 1 0 2 11754
5 1 2 0 6094
5 1 2 2 7138
6 0 1 0 2346
6 0 1 2 4511
6 2 1 0 3253
6 2 1 2 3611
7 0 0 1 17307
7 0 2 1 12394
7 2 0 1 12269
7 2 2 1 12444
8 1 1 1 60
8 1 1 1 390
8 1 1 1 107
8 1 1 1 37
;
data classes;
 set response_times;
 ca=a;
 cb=b;
 cc=c;
ods graphics on;
/* run 1 - Gaussian model  */
/* residuals:              */
/* skewed & too large      */
/* inaccurate assessment of regression */
/* spurrious lack of fit   */
/* misses effect of C      */

proc glimmix data=classes plot=residualpanel;
 class run ca cb cc;
 model r_time=a|a|b|b|c|c@2 ca*cb*cc/solution htype=1;
 random intercept / subject=run;
run;

/* run 2 - gamma GLMM       */
proc glimmix data=classes method=laplace plot=residualpanel(ilink) noprofile;
 class run ca cb cc;
 model r_time=a|a|b|b|c|c@2 ca*cb*cc/d=gamma solution htype=1;
 random intercept / subject=run;
 covtest / cl(type=prl);
run; 

/* run 3 - reduced gamma model                              */
/* with predicted response time at various b-c combinations */
proc glimmix data=classes method=laplace plot=residualpanel;
 class run ca cb cc;
 model r_time=b|b c|c /d=gamma solution htype=1;
 random intercept / subject=run;
 estimate 'bc 0 0' intercept 1 / ilink cl;
 estimate 'bc 0 1' intercept 1 b 0 c 1 b*b 0 c*c 1 / ilink cl;
 estimate 'bc 0 2' intercept 1 b 0 c 2 b*b 0 c*c 4 / ilink cl;
 estimate 'bc 1 0' intercept 1 b 1 c 0 b*b 1 c*c 0 / ilink cl;
 estimate 'bc 1 1' intercept 1 b 1 c 1 b*b 1 c*c 1 / ilink cl;
 estimate 'bc 1 2' intercept 1 b 1 c 2 b*b 1 c*c 4 / ilink cl;
 estimate 'bc 2 0' intercept 1 b 2 c 0 b*b 4 c*c 0 / ilink cl;
 estimate 'bc 2 1' intercept 1 b 2 c 1 b*b 4 c*c 1 / ilink cl;
 estimate 'bc 2 2' intercept 1 b 2 c 2 b*b 4 c*c 4 / ilink cl;
run;
