data multinomial;
 input blk trt slight moderate severe; 
datalines;
1 0 1 4 23
1 1 2 7 23
1 2 4 7 18
2 3 8 8 5
2 4 14 14 7
2 5 14 11 1
3 0 3 6 11
3 1 5 9 15
3 2 9 5 11
4 3 11 9 6
4 4 14 9 3
4 5 14 6 2
5 0 0 6 13
5 1 4 7 16
5 2 12 12 4
6 3 6 14 14
6 4 10 13 8
6 5 16 9 4
7 0 3 9 17
7 1 2 6 22
7 2 3 10 9
8 3 8 13 6
8 4 13 10 1
8 5 17 7 1
9 0 2 3 23
9 1 1 5 19
9 2 2 13 4
10 3 4 2 8
10 4 14 5 11
10 5 12 4 7
;
proc print data=multinomial;
run;
/* get data into form GLIMMIX can use  */
data indiv_data_multinom;
 set multinomial;
 do indiv=1 to slight;  rating=0;  output;
 do indiv=1 to moderate;rating=1;  output;
 do indiv=1 to severe;  rating=2; output; 
proc print data=indiv_data_multinom;
where blk=5 and trt=0;
 var blk trt rating;
run;
/* use NLMIXED to fit GenLogit model by Quadrature */
proc nlmixed data=indiv_data_multinom;
parms int_0=-1 int_1=0.5 tau_00=0 tau_10=0 tau_01=0 tau_11=0 tau_02=0 tau_12=0 tau_03=0 tau_13=0
    tau_04=0 tau_14=0 sdb0=0.1 sdb1=0.1;
eta_0=int_0+(trt=0)*tau_00+(trt=1)*tau_01+(trt=2)*tau_02+(trt=3)*tau_03+(trt=4)*tau_04+blk_0j;
eta_1=int_1+(trt=0)*tau_10+(trt=1)*tau_11+(trt=2)*tau_12+(trt=3)*tau_13+(trt=4)*tau_14+blk_1j;
pi_2=1/(1+exp(eta_0)+exp(eta_1));
pi_1=pi_2*(exp(eta_1)-exp(eta_0));
pi_0=pi_2*(exp(eta_0));
if rating=0 then pi=pi_0;
else if rating=1 then pi=pi_1;
else pi=pi_2;
 p = (pi>0 and pi<=1)*pi + (pi<=0)*1e-8 + (pi>1);
 LL = log(p);
 model rating ~ general(LL);
 random blk_0j blk_1j ~ normal([0,0],[sdb0*sdb0,0,sdb1*sdb1]) subject=blk; 
 estimate 'blk variance for link 0' sdb0*sdb0;
 estimate 'blk variance for link 1' sdb1*sdb1;
 contrast 'separate trt effect by link?' tau_00-Tau_10,tau_01-Tau_11,tau_02-Tau_12,tau_03-Tau_13,tau_04-Tau_14; 
run;
