data multinomial;
 input blk trt slight moderate severe; 
datalines;
1 0 1 4 23
1 1 2 7 23
1 2 4 7 18
2 3 8 8 5
2 4 14 14 7
2 5 14 11 1
3 0 3 6 11
3 1 5 9 15
3 2 9 5 11
4 3 11 9 6
4 4 14 9 3
4 5 14 6 2
5 0 0 6 13
5 1 4 7 16
5 2 12 12 4
6 3 6 14 14
6 4 10 13 8
6 5 16 9 4
7 0 3 9 17
7 1 2 6 22
7 2 3 10 9
8 3 8 13 6
8 4 13 10 1
8 5 17 7 1
9 0 2 3 23
9 1 1 5 19
9 2 2 13 4
10 3 4 2 8
10 4 14 5 11
10 5 12 4 7
;
proc print data=multinomial;
run;
/* get data into form GLIMMIX can use  */
data indiv_data_multinom;
 set multinomial;
 do indiv=1 to slight;  rating=0;  output; end;
 do indiv=1 to moderate;rating=1;  output; end;
 do indiv=1 to severe;  rating=2;  output; end; 
proc print data=indiv_data_multinom;
 var blk trt rating;
run;

/* run 1 - default cumulative logit (proportional odds) model */
 proc glimmix data=indiv_data_multinom;
  class blk trt;
  model rating=trt/dist=multinomial solution oddsratio;
  random intercept / subject=blk solution; 	
  estimate 'c=0, t=0' intercept 1 0 trt 1 0 ,
           'c=1, t=0' intercept 0 1 trt 1 0,
           'c=0, t=1' intercept 1 0 trt 0 1 0,
           'c=1, t=1' intercept 0 1 trt 0 1 0, 
           'c=0, t=2' intercept 1 0 trt 0 0 1 0,
           'c=1, t=2' intercept 0 1 trt 0 0 1 0,
           'c=0, t=3' intercept 1 0 trt 0 0 0 1 0,
           'c=1, t=3' intercept 0 1 trt 0 0 0 1 0,
           'c=0, t=4' intercept 1 0 trt 0 0 0 0 1 0,
           'c=1, t=4' intercept 0 1 trt 0 0 0 0 1 0,
           'c=0, t=5' intercept 1 0 trt 0 0 0 0 0 1,
           'c=1, t=5' intercept 0 1 trt 0 0 0 0 0 1 / ilink bycat;
 run;
 
/* run 2 - generalized logit model  */
proc glimmix data=indiv_data_multinom;
  class rating blk trt;
  model rating=trt/dist=multinomial link=glogit solution oddsratio covB;
  random intercept / subject=blk solution group=rating; 	
  estimate 't=0' intercept 1 trt 1 0 ,
           't=1' intercept 1  trt 0 1 0, 
           't=2' intercept 1  trt 0 0 1 0,
           't=3' intercept 1  trt 0 0 0 1 0,
           't=4' intercept 1  trt 0 0 0 0 1 0,
           't=5' intercept 1  trt 0 0 0 0 0 1 / ilink bycat;
run;
