/* Chapter 15, Section 15.4          */
/* Hessian Fly Data                  */
/* from Gotway & Stroup, 1997, JABES */
/* Various GLMM                      */
/*   including G-side spatial        */

data HessianFly;
  label Y = 'No. of damaged plants'
        n = 'No. of plants';
  input block rep entry lat lng n Y @@;
   plot=lng+8*(lat-1);
   pct=y/n;
  datalines;
   1 1 14 1 1  8 2  1  1 16 1 2  9 1
   2 1  7 1 3 13 9  2  1  6 1 4  9 9
   1 1 13 2 1  9 2  1  1 15 2 2 14 7
   2 1  8 2 3  8 6  2  1  5 2 4 11 8
   3 1 11 3 1 12 7  3  1 12 3 2 11 8
   4 1  2 3 3 10 8  4  1  3 3 4 12 5
   3 1 10 4 1  9 7  3  1  9 4 2 15 8
   4 1  4 4 3 19 6  4  1  1 4 4  8 7
   5 2 15 5 1 15 6  5  2  3 5 2 11 9
   6 2 10 5 3 12 5  6  2  2 5 4  9 9
   5 2 11 6 1 20 10 5  2  7 6 2 10 8
   6 2 14 6 3 12 4  6  2  6 6 4 10 7
   7 2  5 7 1  8 8  7  2 13 7 2  6 0
   8 2 12 7 3  9 2  8  2 16 7 4  9 0
   7 2  9 8 1 14 9  7  2  1 8 2 13 12
   8 2  8 8 3 12 3  8  2  4 8 4 14 7
   9 3  7 1 5  7 7  9  3 13 1 6  7 0
  10 3  8 1 7 13 3  10  3 14 1 8  9 0
   9 3  4 2 5 15 11 9  3 10 2 6  9 7
  10 3  3 2 7 15 11 10  3  9 2 8 13 5
  11  3  6 3 5 16 9 11   3  1 3 6  8 8
  12 3 15 3 7  7 0  12  3 12 3 8 12 8
  11 3 11 4 5  8 1  11  3 16 4 6 15 1
  12 3  5 4 7 12 7  12  3  2 4 8 16 12
  13 4  9 5 5 15 8  13  4  4 5 6 10 6
  14 4 12 5 7 13 5  14  4  1 5 8 15 9
  13 4 15 6 5 17 6  13  4  6 6 6  8 2
  14 4 14 6 7 12 5  14  4  7 6 8 15 8
  15 4 13 7 5 13 2  15  4  8 7 6 13 9
  16 4  3 7 7  9 9  16  4 10 7 8  6 6
  15 4  2 8 5 12 8  15  4 11 8 6  9 7
  16 4  5 8 7 11 10 16  4 16 8 8 15 7
;
/* 1 - RCBD */
proc glimmix data=HessianFly method=laplace; 
 class rep entry;
 model y/n = entry; 
 random intercept / subject=rep;
run;
/* 2 - Incomplete Block */
proc glimmix data=HessianFly method=laplace; 
 class block entry;
 model y/n = entry; 
 random intercept / subject=block;
run;
/* 3 - Spatial GLMM with radial smoothing */
proc glimmix data=HessianFly method=laplace; 
 class plot entry;
   effect sp_rs=spline(lat lng);
   model y/n=Entry sp_rs; 
  random lat lng /  type=rsmooth;
run;
/* 4 alternative spatial GLMM with radial smoothing */
proc glimmix data=HessianFly method=laplace; 
 class plot entry;
 model y/n = entry lat|lat|lat|lng|lng|lng@3; 
 random lat lng /  type=rsmooth;
run;
/* G-side spatial GLMM with spherical covariance */
proc glimmix data=HessianFly method=laplace; 
 class plot entry;
 model y/n = entry;
 random plot / subject=intercept type=sp(sph)(lat lng);
 parms (3) (3);
run;
