/* Chapter 16, Section 16.2     */
/* Power for 3 TRT Binomial GLM */

data power_example_16_2;
input trt p;
N=250;
mu=N*p;
datalines;
0 0.15
1 0.25
2 0.35
;

proc glimmix data=power_example_16_2;
 class trt;
 model mu/N=trt/chisq;
 contrast 'control vs experimental' trt 2 -1 -1/chisq;
 contrast 'control vs exp 1' trt 1 -1 0/chisq;
 contrast 'control vs exp 2' trt 1 0 -1/chisq;
 contrast 'exp 1 vs exp 2' trt 0 1 -1/chisq;
 lsmeans trt/diff cl;
 ods output tests3=F_overall contrasts=F_contrasts;
run;

data power;
 set F_overall F_contrasts;
  nc_parm=numdf*Fvalue;
  alpha=0.05;
  F_Crit=Cinv(1-alpha,numdf,0);
  Power=1-probchi(F_crit,numdf,nc_parm);
proc print data=power;
run;
