/* Chapter 16 - Section 16.1.2 */
/*  Power for 3 trt CRD        */

/* 1 - create exemplary data */
data power_example_1;
input trt mu;
do obs=1 to 5;
output;
end;
datalines;
0 20
1 25
2 25
;
/* 2 - GLIMMIX step */
proc glimmix data=power_example_1;
 class trt;
 model mu=trt;
 parms (9)/hold=1;
 contrast control vs experimental trt 2 -1 -1;
 contrast control vs exp 1 trt 1 -1 0;
 contrast control vs exp 2 trt 1 0 -1;
 contrast exp 1 vs exp 2 trt 0 1 -1;
 lsmeans trt/diff cl;
 ods output tests3=F_overall contrasts=F_contrasts;
run;
/* 3 - Compute Power using Prob functions */
data power;
 set F_overall F_contrasts;
  nc_parm=numdf*Fvalue;
  alpha=0.05;
  F_Crit=Finv(1-alpha,numdf,dendf,0);
  Power=1-probF(F_crit,numdf,dendf,nc_parm);
proc print data=power;
run;
