/* Chapter 16, Section 16.5.1      */
/* Power for Repeated Measures LMM */
data rptM_power;
 input trt @@;
  n_subjects=6;
  do hour=1 to 8;
   input mu @@;
    do subj_id=1 to n_subjects;
     output;
    end;
  end;
datalines;
0 3 3 3 3 3 3 3 3
1 6.5 6 5.5 5 4.5 4 3.5 3
2 5.5 5.5 5.5 5.5 5.5 5.25 4.5 3.5
;
proc print data=rptM_Power;
run;
proc glimmix data=rptM_power noprofile;
 class trt hour subj_id;
 model mu=trt|hour;
 random _residual_/type=ar(1) subject=subj_id;
  parms (4)(0.6)/hold=1,2;
 lsmeans trt*hour/slice=(trt hour);
 ods output tests3=overall_F slices=simple_effects;
run;

data power;
 set overall_F simple_effects;
  nc_parm=numdf*Fvalue;
  alpha=0.05;
  F_Crit=Finv(1-alpha,numdf,dendf,0);
  Power_F=1-probF(F_crit,numdf,dendf,nc_parm);
proc print data=power;
run;
