/* data set for examples 2.b.5 and 2.b.6         */
/* shown in book - models with Gaussian data (Y) */
/* addition - not shown in book: 
       models with Binomial data (Fav/N)         */

data example_2_b_5;
input x @@;
do batch=1 to 4;
 input Y Fav N @@;
 output;
end;
datalines;
0 95.6 15 21 96.8 18 21 96.6 16 19 96.6 18 21
3 96.9 13 17 96.7 14 16 96.5 13 19 96.8 18 21
6 98.5 19 23 96.3 14 17 97.7 17 22 96.4 14 20
9 99.0 14 17 96.3 17 20 98.3 23 27 96.6 14 19
12 100.2 18 23 96.5 15 20 99.1 16 21 96.8 14 19
18 101.9 19 27 96.4 14 22 100.5 11 16 96.9 11 20
24 104.1 15 20 95.7 12 22 101.2 13 18 97.1 11 16
36 107.8 14 21 95.2 11 25 103.3 10 17 97.4 10 21
48 111.5 13 18 94.6 5 26 105.9 6 16 97.4 5 19
;
proc sort; by batch;
proc print; run;
/* Gaussian Data - response variable Y */
/* Batch effects fixed                 */
/* Example 2.B.5 4 regressions         */
proc glimmix data=example_2_b_5;
 class batch;
 model y=x batch(x) / solution;
run;
/* alternative non-full-rank effects model                          */
/* dividing intercept & slope into overall and batch-specific parts */ 
proc glimmix data=example_2_b_5;
 class batch;
 model y=batch x batch*x / solution;
run;
/* alternative fixed batch effect: shorthand batch|x = batch x batch*x */
proc glimmix data=example_2_b_5;
 class batch;
 model y=batch|x / solution;
run;
/* Batch effects random */
proc glimmix data=example_2_b_5;
 class batch;
 model y=x/solution;
 random intercept x / subject=batch;
run;

/* Binomial Data - response variable Fav/N */
/* Batch effects fixed                     */
proc glimmix data=example_2_b_5;
 class batch;
 model Fav/N=x batch(x) / solution;
run;
proc glimmix data=example_2_b_5;
 class batch;
 model Fav/N=batch x batch*x / solution;
run;
/* alternative fixed batch effect: shorthand batch|x = batch x batch*x */
proc glimmix data=example_2_b_5;
 class batch;
 model Fav/N=batch|x / solution;
run;
/* Batch effects random */
proc glimmix data=example_2_b_5;
 class batch;
 model Fav/N=x/solution;
 random intercept x / subject=batch;
run;
