data example_2_b_7;
/* use this data set for examples 2.b.7 and 2.b.9 */
/* ignore REP in example 2.b.7 */
/* use it to define various whole-plot configurations in 2.b.9 */
 input Rep A B y;
datalines;
1 1 1 41
1 1 2 40.6
1 2 1 42.7
1 2 2 37.1
2 1 1 40
2 1 2 37.1
2 2 1 39.3
2 2 2 24.2
3 1 1 38.2
3 1 2 36.5
3 2 1 34.6
3 2 2 30
4 1 1 44.7
4 1 2 38.8
4 2 1 47.9
4 2 2 34.8
;
/* Example 2.B.7                                                             */
/* ignore REP - treat data set as a CRD                                      */
/* your task here is to learn ways to work with the treatment (A x B) design */
proc glimmix data=example_2_b_7;
 class a b;
 model y=a b a*b / solution;
run;
proc glimmix data=example_2_b_7;
 class a b;
 model y=a*b / solution;
run;
proc glimmix data=example_2_b_7;
 class a b;
 model y=a b a*b / noint solution;
run;
proc glimmix data=example_2_b_7;
 class a b;
 model y=a b(a) / solution;
run;
proc glimmix data=example_2_b_7;
 class a b;
 model y=a a*b / solution;
run;
proc glimmix data=example_2_b_7;
 class a b;
 model y=a b(a) / noint solution;
run;
proc glimmix data=example_2_b_7;
 class a b;
 model y=a a*b / noint solution;
run;

/* example 2.b.9 */

/* now use REP */
/* note it can be used to define many different designs */
/* for all designs, a|b shorthand is shown              */
/* HOWEVER -- you can use ANY variation shown above
     in specifying the A x B effects                    */
/* e.g. a*b / noint;  a b(a); etc etc                   */
/* not shown in book - RCBD                             */
/* block effects fixed */
proc glimmix data=example_2_b_7;
 class rep a b;
 model y=rep a|b / solution;
run;
/* block effects random */
proc glimmix data=example_2_b_7;
 class a b;
 model y=a|b / solution;
 random intercept / subject=rep;
run;
/* block effects random */
/* alternative way to specify random effect */
proc glimmix data=example_2_b_7;
 class rep a b;
 model y=a|b / solution;
 random rep;
run;

/* whole plot a CRD */
/* rep(a) equivalent to exp_unit(a) term used in textbook */
proc glimmix data=example_2_b_7;
 class rep a b;
 model y=a|b / solution;
 random rep(a);
run;
/* alternative - prefered - way to specify whole-plot effect */
proc glimmix data=example_2_b_7;
 class rep a b;
 model y=a|b / solution;
 random a / subject=rep;
run;
/* alternative - this also works to specify exp_unit(a) */
proc glimmix data=example_2_b_7;
 class rep a b;
 model y=a|b / solution;
 random rep*a;
run;

/* whole plot a RCBD */
/* rep equivalent to block; latter used in textbook */
proc glimmix data=example_2_b_7;
 class rep a b;
 model y=a|b / solution;
 random rep rep*a;
run;
/* alternative - prefered - way to specify whole-plot effect */
proc glimmix data=example_2_b_7;
 class rep a b;
 model y=a|b / solution;
 random intercept a / subject=rep;
run;

/* strip-plot  */
/* rep equivalent to block as used in textbook */
proc glimmix data=example_2_b_7;
 class rep a b;
 model y=a|b / solution;
 random rep rep*a rep*b;
run;
/* alternative - prefered - way to specify strip-plot random terms */
proc glimmix data=example_2_b_7;
 class rep a b;
 model y=a|b / solution;
 random intercept a b / subject=rep;
run;
