/* Example 3.D.2 - Gaussian response variable */
/* Multi-batch random coefficient regression  */
/* Use Data Set 3.3                           */
 proc glimmix data=multi_batch_1;
 class batch;
 model Y = X / solution;
 *random intercept X / solution subject=batch type=un gcorr;
 random intercept X / solution subject=batch;
 estimate 'PA intercept' intercept 1;
 estimate 'PA slope'    X 1;
 estimate 'PA y-hat at X=10' intercept 1 x 10;
 estimate 'SS intercept for batch 1' intercept 1 | intercept 1 / subject 1 0 0 0;
 estimate 'SS intercept for batch 2' intercept 1 | intercept 1 / subject 0 1 0 0;
 estimate 'SS intercept for batch 3' intercept 1 | intercept 1 / subject 0 0 1 0;
 estimate 'SS intercept for batch 4' intercept 1 | intercept 1 / subject 0 0 0 1;
 estimate 'SS slope for batch 1' x 1 | x 1,
          'SS slope for batch 2' x 1 | x 1,
          'SS slope for batch 3' x 1 | x 1,
          'SS slope for batch 4' x 1 | x 1
   / subject 1 0 0 0, 0 1 0 0, 0 0 1 0, 0 0 0 1 adjust=bonferroni;
 estimate 'SS y-hat @ X=10, batch 1 ' intercept 1 x 10 | intercept 1 x 10 / subject 1 0 0 0;
 estimate 'SS y-hat @ X=10, batch 2 ' intercept 1 x 10 | intercept 1 x 10 / subject 0 1 0 0;
 estimate 'SS diff @ x=10, batch 1 v 2' | intercept 1 x 10 / subject 1 -1 0 0;
 estimate 'SS y-hat @ x=10, avg batch 1+2' intercept 2 x 20 
     | intercept 1 x 10 / subject 1 1 0 0 divisor=2;
 run;
