/* Example 3.E.1                             */
/* binomial response, random location effect */
/* Use Data Set 3.2                          */

/* Run 1 - normal approximation              */
proc glimmix data=MultiLoc_4Trt;
 class loc trt;
  Pct=S_1/N_Bin;
 model Pct = trt / solution;
 random intercept trt / subject=loc;
 lsmeans trt;
run;

/* Run 2 - Binomial GLMM                     */
/*  As shown in Figure 3.9                   */
proc glimmix data=MultiLoc_4Trt;
 class loc trt;
 model S_1/N_Bin= trt / solution;
 random intercept / subject=loc;
 lsmeans trt / ilink;
run;

/* Run 3 - Binomial GLMM                     */
/* with additional loc*trt random effect     */
/*  As shown in Figure 3.13                  */
proc glimmix data=MultiLoc_4Trt;
 class loc trt;
 model S_1/N_Bin= trt / solution;
 random intercept trt / subject=loc;
 /* or alternatively  random loc loc*trt;    */
 lsmeans trt / ilink;
run;
