/* SAS for MM, 2nd ed, Chapter 2, Cochran & Cox PBIB example    */
/* Data from Cochran and Cox (1957) Experimental Design         */
/*   example appears on page 456 of Cochran and Cox             */

data cc456;
 input bloc trt y @@;
datalines;
 1 15 24  1  9 25  1  1 26  1 13 20
 2  5 27  2  7 28  2  8 24  2  1 27
 3 10 26  3  1 28  3 14 24  3  2 24
 4 15 34  4 11 31  4  2 21  4  3 23
 5  6 41  5 15 33  5  4 33  5  7 29
 6 12 34  6  4 32  6  3 28  6  1 30
 7 12 32  7 14 25  7 15 24  7  8 26
 8  6 23  8  3 23  8 14 24  8  5 27
 9  5 28  9  4 28  9  2 26  9 13 25
10 10 25 10 12 27 10 13 28 10  6 26
11  9 26 11  7 26 11 10 23 11  3 24
12  8 27 12  6 27 12  2 25 12  9 26
13  5 30 13  9 36 13 11 32 13 12 32
14  7 30 14 13 28 14 14 24 14 11 25
15 10 24 15  4 25 15  8 32 15 11 31
;
/* fixed block analysis  */
proc glimmix data=cc456;
 class trt bloc;
  model y=bloc trt;
run;
/* you can verify results are identical to ANOVA */
/*  by running same analysis using PROC GLM      */
proc glm data=cc456;
 class trt bloc;
  model y=bloc trt;
run;
/* default mixed model analysis using             */
/*    REML variance component estimates           */
/* change GLIMMIX to MIXED will duplicate example */
/* shown in Chapter 2, Littell, et al             */
proc glimmix data=cc456;
 class trt bloc;
  model y=trt;
  random intercept / subject=bloc;
 run;
/*  mixed model analysis using                      */
/*    ML variance component estimates               */
/* method=laplace or method=quad yields same result */
proc glimmix data=cc456 method=mspl/*laplace*/;
 class trt bloc;
  model y=trt;
  random intercept / subject=bloc;
 run;
