data Ch7_ANCOV_2;
 input Trt X y;
datalines;
1 8 48.144105196
1 7 46.177825748
1 7 50.35056507
1 6 46.567102379
1 10 44.563647239
2 8 47.911847849
2 7 48.429641512
2 6 47.659985383
2 13 23.55900215
2 9 42.779732188
3 10 34.876165783
3 16 4.7682066721
3 8 40.915108364
3 9 36.714416859
3 12 29.001040633
4 16 20.233939673
4 14 23.91923376
4 9 37.128833271
4 5 44.749893092
4 13 25.008424881
;
/* box plots of covariate (X) by Trt */
proc sgplot data=Ch7_ANCOV_2;
  title "Litter Sizes by Treatment";
  hbox x / category=Trt;
  title 'covariate by treatment';
run;
/* 1 - test equality of slopes */
/*  and additional mean comparisons conditional on selected X */
/*  required because of strong evidence of unequal slopes     */
proc glimmix data=Ch7_ANCOV_2;
 class trt;
 model y=trt x x*trt / solution;
 contrast 'trt at x=0' trt 1 0 0 -1,
                       trt 0 1 0 -1,
					   trt 0 0 1 -1;
 contrast 'trt at x=9.65' trt 1 0 0 -1 x*trt 9.65 0 0 -9.65,
                          trt 0 1 0 -1 x*trt 0 9.65 0 -9.65,
					      trt 0 0 1 -1 x*trt 0 0 9.65 -9.65;
 lsmeans trt / at x=7 diff lines;
 lsmeans trt / at x=12 diff lines; 
run;
/* alternative parameterization */
/* solution much easier to read because it gives regression parameters from full rank model */
/* notice that all inference you do above can be done here as well                          */
/* you just have to use syntax consistent with model                                        */ 
proc glimmix data=Ch7_ANCOV_2;
 class trt;
 model y=trt x(trt) / noint solution;
 contrast 'equal slopes' x(trt) 1 0 0 -1,
                         x(trt) 0 1 0 -1,
						 x(trt) 0 0 1 -1;
 contrast 'trt at x=0' trt 1 0 0 -1,
                       trt 0 1 0 -1,
					   trt 0 0 1 -1;
 contrast 'trt at x=9.65' trt 1 0 0 -1 x(trt) 9.65 0 0 -9.65,
                          trt 0 1 0 -1 x(trt) 0 9.65 0 -9.65,
					      trt 0 0 1 -1 x(trt) 0 0 9.65 -9.65;
 lsmeans trt / at x=7 diff lines;
 lsmeans trt / at x=12 diff lines; 
run;
