data example_7_6_1;
/* 2nd order response surface */
 input a b response;
 xa=10*a;
 xb=10*b;
datalines;
1 1 64
1 1 55
1 1 68
1 1 61
1 2 57
1 2 55
1 2 53
1 2 60
1 3 49
1 3 51
1 3 50
1 3 46
1 4 49
1 4 48
1 4 54
1 4 51
1 5 46
1 5 52
1 5 57
1 5 71
2 1 51
2 1 44
2 1 62
2 1 50
2 2 59
2 2 55
2 2 46
2 2 54
2 3 51
2 3 52
2 3 39
2 3 51
2 4 50
2 4 53
2 4 47
2 4 55
2 5 57
2 5 61
2 5 61
2 5 57
3 1 46.4
3 1 50.4
3 1 46.4
3 1 48.4
3 2 43
3 2 56
3 2 42
3 2 51
3 3 44
3 3 59
3 3 48
3 3 50
3 4 50
3 4 55
3 4 50
3 4 54
3 5 56
3 5 57
3 5 60
3 5 64
4 1 48
4 1 52
4 1 49
4 1 57
4 2 62
4 2 52
4 2 49
4 2 58
4 3 61
4 3 59
4 3 50
4 3 47
4 4 67
4 4 59
4 4 65
4 4 69
4 5 77
4 5 72
4 5 76
4 5 74
5 1 55
5 1 56
5 1 47
5 1 59
5 2 61
5 2 58
5 2 56
5 2 57
5 3 65
5 3 62
5 3 65
5 3 65
5 4 75
5 4 84
5 4 69
5 4 77
5 5 88
5 5 83
5 5 84
5 5 86
;
/* plot the surface */
/* first create a data set of the 25 xa*xb means */
proc glimmix data=example_7_6_1;
 class xa xb;
 model response=xa*xb;
 lsmeans xa*xb;
 ods output lsmeans=lsm;
/* now plot them */
/* the plot you see may not look EXACTLY like figure on page 229     */
/*  but it is                                                        */
/* the numbers used here are the numbers used for susequent analysis */
proc g3d data=lsm;
 plot xa*xb=estimate/rotate=40 tilt=60 xticknum=5 yticknum=5 zmin=45 zmax=80 zticknum=8 side grid;
run;

/* GLIMMIX run to test lack of fit  */
proc glimmix data=example_7_6_1;
 class a b;
 model response=xa|xa|xb|xb@2 a*b/htype=1;
run;

/* fit and plot estimated 2nd order polynomial      */
/* PROC GLM allows you to output predicted response
     in form easily used by PROC G3D                */
/* okay here because this is a LM                   */
proc glm data=example_7_6_1;
 model response=xa|xa|xb|xb@2/p;
 output out=est_rs p=y_hat;
run; 
proc g3d data=est_rs;
 plot xa*xb=y_hat/rotate=40 tilt=60 xticknum=5 yticknum=5 zmin=45 zmax=90 zticknum=6 side grid;
 title 'estimated 2nd order response surface';
run;
