/* nonlineat response surface example */
data example_7_6_2;
 input x1 x2 response;
  if x1=0 then logx1=log(x1+0.1);
   else logx1=log(x1);
  if x2=0 then logx2=log(x2+0.1);
   else logx2=log(x2);
datalines;
0 0 7.6
0 1 6.9
0 2 8.1
0 3 8.7
0 4 7.7
1 0 7.4
1 1 14.1
1 2 13.8
1 3 13.8
1 4 14
2 0 7.6
2 1 13.3
2 2 15.4
2 3 14.8
2 4 15.8
3 0 6.1
3 1 11.7
3 2 15.8
3 3 17.1
3 4 15.2
4 0 5.7
4 1 14.4
4 2 16.6
4 3 17
4 4 16.2
;

/* estimate 2nd order response surface */
proc glm data=example_7_6_2;;
 model response=x1|x1|x2|x2@2/p;
 output out=classical p=cy_hat;
run;
/* estimate Hoerl responss surface  */
proc glm data=example_7_6_2;;
 model response=x1|x2 logx1|logx2/p;
 output out=hoerl p=hy_hat;
run;
/* plot data */
proc g3d data=example_7_6_2;;
 *plot x1*x2=response/xticknum=5 yticknum=5 zmin=0 zmax=20 zticknum=5 ctop=black grid;
 scatter x1*x2=response/xticknum=5 yticknum=5 zmin=0 zmax=20 zticknum=5 grid color='black';
 title 'response by A and B';
run;
/* plot est 2nd order rs */
proc g3d data=classical;
 plot x1*x2=cy_hat/xticknum=5 yticknum=5 zmin=0 zmax=20 zticknum=5 ctop=black grid;
 title 'estimated 2nd order response surface';
run;
/* plot est Hoerl rs */
proc g3d data=hoerl;
 plot x1*x2=hy_hat/xticknum=5 yticknum=5 zmin=0 zmax=20 zticknum=5 ctop=black grid;
 title 'estimated linearized Hoerl response surface';
run;
